<?php



class FirstDataTransaction extends ObjectModel {

	public $id;
	public $id_order;
	public $status;
	public $error;
	public $msg;
	public $fd_tid;
	public $card_number;
	public $card_brand;
	public $card_expiration;
	public $card_holder;
	public $date_add;
	public $date_mod = null;
	public $date_accept = null;
	public $date_cancel = null;

	public static $definition = array(
		'table' => 'firstdata_transaction',
		'primary' => 'id_transaction',
		'fields' => array(
			'id_order' => 			array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'status' => 			array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'error' => 				array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'msg' => 				array('type' => self::TYPE_STRING, 'validate' => 'isString'),
			'fd_tid' => 			array('type' => self::TYPE_STRING, 'validate' => 'isString'),
			'date_add' => 			array('type' => self::TYPE_DATE, 'validate' => 'isDate'),
			'date_mod' => 			array('type' => self::TYPE_DATE),
			'date_accept' => 		array('type' => self::TYPE_DATE),
			'date_cancel' => 		array('type' => self::TYPE_DATE),
		    'card_number' => 		array('type' => self::TYPE_STRING, 'validate' => 'isString'),
		    'card_brand' => 		array('type' => self::TYPE_STRING, 'validate' => 'isString'),
		    'card_expiration' => 	array('type' => self::TYPE_STRING, 'validate' => 'isString'),
		    'card_holder' => 		array('type' => self::TYPE_STRING, 'validate' => 'isString'),
		),
	);

	public static function getIdByFDId($tid) {
		return Db::getInstance()->getValue("
			SELECT id_transaction
			FROM `"._DB_PREFIX_."firstdata_transaction`
			WHERE
				`fd_tid`='". pSQL($tid) ."'
		");
	}

	public static function getIdByOId($oid) {
		return Db::getInstance()->getValue("
			SELECT id_transaction
			FROM `"._DB_PREFIX_."firstdata_transaction`
			WHERE
                `id_transaction`=(SELECT id_transaction FROM `"._DB_PREFIX_."firstdata_transaction` WHERE `id_order`='". pSQL($oid) ."' ORDER BY id_transaction DESC LIMIT 1)
		");
	}

	public static function getList($filters = array(), $orderBy = 'id_order', $orderWay = 'ASC', $page = 1, $enum = 25) {
		$query = "
			SELECT SQL_CALC_FOUND_ROWS
				o.*
			FROM `"._DB_PREFIX_.static::$definition['table']."` AS o
			";
		
		# where clause
		$where = "status!=999";
		foreach($filters as $field => $value)
			$where .= ($where ? " AND " : ""). "`". pSQL($field) ."`='". pSQL($value) ."'";
			
		if($where)
			$query .= " WHERE ".$where;
			
		# order
		$query .= " ORDER BY `". pSQL($orderBy) ."` ". ($orderWay == 'ASC' ? 'ASC' : 'DESC');
		
		# limit
		$query .= " LIMIT ". ($enum*($page-1)) .", ". $enum;
		
		
		$records = Db::getInstance()->executeS($query);
		$total = Db::getInstance()->getValue('SELECT FOUND_ROWS() AS `'._DB_PREFIX_.static::$definition['table'].'`', false);
	
		return array(
			'records' => $records,
			'total' => $total,
		);
	}

	public static function getPendingList() {
		$query = "
			SELECT o.*
			FROM `"._DB_PREFIX_.static::$definition['table']."` AS o
			WHERE status=1";
		$records = Db::getInstance()->executeS($query);
		return $records;
	}

	public static function getNotRegisteredList($days) {
		$query = "
			SELECT o.id_order, o.date_add
			FROM `"._DB_PREFIX_."orders` AS o
			WHERE module='firstdata' AND date_add>DATE_SUB(now(), INTERVAL $days DAY) AND id_order NOT IN
				(SELECT id_order FROM `"._DB_PREFIX_.static::$definition['table']."`)";
		$records = Db::getInstance()->executeS($query);
		return $records;
	}

	public function getPaymentId() {
		return Db::getInstance()->getValue("
			SELECT id_order_payment
			FROM `"._DB_PREFIX_."order_payment`
			WHERE
				`transaction_id`='". pSQL($this->fd_tid) ."'
		");
	}
	
}
